/* -*- C++ -*-  vim:set syntax=cpp: 
 *
 * (C) 2004-2010 Frank-Rene Schaefer
 * ABSOLUTELY NO WARRANTY              */
#ifndef QUEX_INCLUDE_GUARD_TestAnalyzer__ANALYZER__MODE_I
#define QUEX_INCLUDE_GUARD_TestAnalyzer__ANALYZER__MODE_I

#include "test_c_emm/lib/definitions"



 void
TestAnalyzer_Mode_uncallable_analyzer_function(struct TestAnalyzer_tag* me)
{ 
    __quex_assert(0); 
    (void)me;
    return; 
}


 void
TestAnalyzer_Mode_on_indentation_null_function(struct TestAnalyzer_tag* lexer, TestAnalyzer_indentation_t Indentation, TestAnalyzer_lexatom_t* Begin)
{ (void)lexer; (void)Indentation; (void)Begin; }


 void
TestAnalyzer_Mode_on_entry_exit_null_function(struct TestAnalyzer_tag* me, const TestAnalyzer_Mode* TheMode) 
{ (void)me; (void)TheMode; }

 bool
TestAnalyzer_ModeStack_construct(TestAnalyzer_ModeStack* me, const size_t N)
{
    me->begin = (const TestAnalyzer_Mode**)quex_MemoryManager_allocate(
                                N * sizeof(TestAnalyzer_Mode*),
                                E_MemoryObjectType_MODE_STACK);
    if( ! me->begin ) {
        TestAnalyzer_ModeStack_resources_absent_mark(me);
        return false;
    }
    else {
        me->end        = &me->begin[0];
        me->memory_end = &me->begin[N];
        return true;
    }
}

 void
TestAnalyzer_ModeStack_destruct(TestAnalyzer_ModeStack* me)
{
    if( me->begin ) {
        quex_MemoryManager_free((void*)&me->begin[0],
                                   E_MemoryObjectType_MODE_STACK);
    }
    TestAnalyzer_ModeStack_resources_absent_mark(me);
}

 void
TestAnalyzer_ModeStack_resources_absent_mark(TestAnalyzer_ModeStack* me)
{
    me->begin      = (const TestAnalyzer_Mode**)0;
    me->end        = (const TestAnalyzer_Mode**)0;
    me->memory_end = (const TestAnalyzer_Mode**)0;
}

 bool
TestAnalyzer_ModeStack_resources_absent(TestAnalyzer_ModeStack* me)
{
    return    me->end        == (const TestAnalyzer_Mode**)0
           && me->memory_end == (const TestAnalyzer_Mode**)0;
}

 void
TestAnalyzer_ModeStack_print(TestAnalyzer_ModeStack* me)
{
    const TestAnalyzer_Mode** iterator = 0x0;
    if( TestAnalyzer_ModeStack_resources_absent(me) ) {
        QUEX_DEBUG_PRINT("<uninitialized>\n");
    }
    else {
        QUEX_DEBUG_PRINT("{\n");
        QUEX_DEBUG_PRINT1("    size:    %i;\n",
                          (int)(me->memory_end - me->begin));
        QUEX_DEBUG_PRINT("    content: [");
        if( me->end > me->memory_end || me->end < me->begin ) {
            QUEX_DEBUG_PRINT("<pointer corrupted>");
        }
        else {
            for(iterator=&me->end[-1]; iterator >= me->begin; --iterator) {
                QUEX_DEBUG_PRINT1("%s, ", (*iterator)->name);
            }
        }
        QUEX_DEBUG_PRINT("]\n");
        QUEX_DEBUG_PRINT("  }\n");
    }
}



#endif /* QUEX_INCLUDE_GUARD_TestAnalyzer__ANALYZER__MODE_I */
