/* -*- C++ -*- vim:set syntax=cpp: 
 * (C) Frank-Rene Schaefer    
 * ABSOLUTELY NO WARRANTY                                                     */
#ifndef QUEX_INCLUDE_GUARD_TestAnalyzer__LEXEME__BASICS_I
#define QUEX_INCLUDE_GUARD_TestAnalyzer__LEXEME__BASICS_I

#include "test_c_emm/lib/quex/standard_functions"
#include "test_c_emm/lib/quex/MemoryManager"



extern TestAnalyzer_lexatom_t TestAnalyzer_LexemeNull;

 size_t 
TestAnalyzer_lexeme_length(const TestAnalyzer_lexatom_t* Str)
{
    const TestAnalyzer_lexatom_t* iterator = Str;
    while( *iterator ) ++iterator; 
    return (size_t)(iterator - Str);
}

 TestAnalyzer_lexatom_t*
TestAnalyzer_lexeme_clone(const TestAnalyzer_lexatom_t* BeginP,
                        size_t                   Length)
{
    TestAnalyzer_lexatom_t* result;

    if( ! BeginP || ! *BeginP ) {
        return &TestAnalyzer_LexemeNull;
    }
    
    result = (TestAnalyzer_lexatom_t*)quex_MemoryManager_allocate(
                   sizeof(TestAnalyzer_lexatom_t) * (Length + 1),
                   E_MemoryObjectType_TEXT);

    if( result ) {
        memcpy((void*)result, (void*)BeginP, 
                          sizeof(TestAnalyzer_lexatom_t) * (Length + 1));
    }
    else {
        result = &TestAnalyzer_LexemeNull; 
    }
    return result;
}

 size_t 
TestAnalyzer_lexeme_compare(const TestAnalyzer_lexatom_t* it0, 
                          const TestAnalyzer_lexatom_t* it1)
{
    for(; *it0 == *it1; ++it0, ++it1) {
        /* Both letters are the same and == 0?
         * => both reach terminall zero without being different.              */
        if( *it0 == 0 ) return 0;
    }
    return (size_t)(*it0) - (size_t)(*it1);
}



#endif /* QUEX_INCLUDE_GUARD_TestAnalyzer__LEXEME_BASICS_I */
