
#include "test_cpp/TestAnalyzer"
#include "test_cpp/lib/implementations.i"



TestAnalyzer_Mode TestAnalyzer_M = {
    /* name               */ "M",

    /* on_indentation     */ TestAnalyzer_Mode_on_indentation_null_function,

    /* on_entry           */ TestAnalyzer_M_on_entry,
    /* on_exit            */ TestAnalyzer_M_on_exit,
#   if      defined(QUEX_OPTION_ASSERTS)
    /* has_base           */ TestAnalyzer_M_has_base,
    /* has_entry_from     */ TestAnalyzer_M_has_entry_from,
    /* has_exit_to        */ TestAnalyzer_M_has_exit_to,
#   endif
    {
    /* on_buffer_before_change */ TestAnalyzer_M_on_buffer_before_change,
    /* on_buffer_overflow      */ TestAnalyzer_M_on_buffer_overflow,
    /* aux                     */ (void*)0,
    },

    /* analyzer_function */ TestAnalyzer_M_analyzer_function
};
TestAnalyzer_Mode TestAnalyzer_M2 = {
    /* name               */ "M2",

    /* on_indentation     */ TestAnalyzer_Mode_on_indentation_null_function,

    /* on_entry           */ TestAnalyzer_M2_on_entry,
    /* on_exit            */ TestAnalyzer_M2_on_exit,
#   if      defined(QUEX_OPTION_ASSERTS)
    /* has_base           */ TestAnalyzer_M2_has_base,
    /* has_entry_from     */ TestAnalyzer_M2_has_entry_from,
    /* has_exit_to        */ TestAnalyzer_M2_has_exit_to,
#   endif
    {
    /* on_buffer_before_change */ TestAnalyzer_M2_on_buffer_before_change,
    /* on_buffer_overflow      */ TestAnalyzer_M2_on_buffer_overflow,
    /* aux                     */ (void*)0,
    },

    /* analyzer_function */ TestAnalyzer_M2_analyzer_function
};

#   ifdef     self
#       undef self
#   endif
#   define self (*((TestAnalyzer*)me))
#define LexemeNull  (&TestAnalyzer_LexemeNull)
#define FLUSH       return

void
TestAnalyzer_M_on_entry(TestAnalyzer* me, const TestAnalyzer_Mode* FromMode) {
    (void)me;
    (void)FromMode;
#   ifdef QUEX_OPTION_ASSERTS
    TestAnalyzer_M.has_entry_from(FromMode);
#   endif

}

void
TestAnalyzer_M_on_exit(TestAnalyzer* me, const TestAnalyzer_Mode* ToMode)  {
    (void)me;
    (void)ToMode;
#   ifdef QUEX_OPTION_ASSERTS
    TestAnalyzer_M.has_exit_to(ToMode);
#   endif

}



#ifdef QUEX_OPTION_ASSERTS
bool
TestAnalyzer_M_has_base(const TestAnalyzer_Mode* Mode) {
    (void)Mode;
return false;
}

bool
TestAnalyzer_M_has_entry_from(const TestAnalyzer_Mode* Mode) {
    (void)Mode;
if( Mode == &TestAnalyzer_M2 ) {

    return true;

    }

    else {
    return false;
    }
}

bool
TestAnalyzer_M_has_exit_to(const TestAnalyzer_Mode* Mode) {
    (void)Mode;
if( Mode == &TestAnalyzer_M2 ) {

    return true;

    }

    else {
    return false;
    }
}
#endif    

void
TestAnalyzer_M_on_buffer_before_change(void* me /* 'aux' -> 'self' via 'me' */)
{
#   ifdef     self
#       undef self
#   endif
#   define self (*((TestAnalyzer*)me))


    const TestAnalyzer_lexatom_t* BufferBegin = self.buffer.begin(&self.buffer);
    const TestAnalyzer_lexatom_t* BufferEnd   = self.buffer.end(&self.buffer);
    (void)me; (void)BufferBegin; (void)BufferEnd;

}

inline void
TestAnalyzer_Buffer_print_overflow_message(TestAnalyzer_Buffer* buffer); 

void
TestAnalyzer_M_on_buffer_overflow(void*  me /* 'aux' -> 'self' via 'me' */)
{
#   ifdef     self
#       undef self
#   endif
#   define self (*((TestAnalyzer*)me))

    const TestAnalyzer_lexatom_t* LexemeBegin = self.buffer._lexeme_start_p;
    const TestAnalyzer_lexatom_t* LexemeEnd   = self.buffer._read_p;
    const size_t             BufferSize  = (size_t)(self.buffer.size(&self.buffer)); 


    /* Try to double the size of the buffer, by default.                      */
    if( ! TestAnalyzer_Buffer_nested_negotiate_extend(&self.buffer, 2.0) ) {
        TestAnalyzer_MF_error_code_set_if_first(&self, E_Error_Buffer_Overflow_LexemeTooLong);
        TestAnalyzer_Buffer_print_overflow_message(&self.buffer);
    }

    (void)me; (void)LexemeBegin; (void)LexemeEnd; (void)BufferSize;
}

void
TestAnalyzer_M2_on_entry(TestAnalyzer* me, const TestAnalyzer_Mode* FromMode) {
    (void)me;
    (void)FromMode;
#   ifdef QUEX_OPTION_ASSERTS
    TestAnalyzer_M2.has_entry_from(FromMode);
#   endif

}

void
TestAnalyzer_M2_on_exit(TestAnalyzer* me, const TestAnalyzer_Mode* ToMode)  {
    (void)me;
    (void)ToMode;
#   ifdef QUEX_OPTION_ASSERTS
    TestAnalyzer_M2.has_exit_to(ToMode);
#   endif

}


void
TestAnalyzer_M2_on_indentation(TestAnalyzer*    me, 
                TestAnalyzer_indentation_t  Indentation, 
                TestAnalyzer_lexatom_t*     Begin) 
{
#   ifdef     self
#       undef self
#   endif
#   define self (*((TestAnalyzer*)me))


    /* Lexeme setup: 
     *
     * There is a temporary zero stored at the end of each lexeme, if the action 
     * references to the 'Lexeme'. 'LexemeNull' provides a reference to an empty
     * zero terminated string.                                                    */
#if defined(QUEX_OPTION_ASSERTS)
#   define Lexeme       TestAnalyzer_access_Lexeme((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#   define LexemeBegin  TestAnalyzer_access_LexemeBegin((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#   define LexemeL      TestAnalyzer_access_LexemeL((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#   define LexemeEnd    TestAnalyzer_access_LexemeEnd((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#else
#   define Lexeme       (me->buffer._lexeme_start_p)
#   define LexemeBegin  Lexeme
#   define LexemeL      ((size_t)(me->buffer._read_p - me->buffer._lexeme_start_p))
#   define LexemeEnd    me->buffer._read_p
#endif

#define LexemeNull      (&TestAnalyzer_LexemeNull)

#define LineNEnd   me->counter._line_number_at_end
#define LineN      me->counter._line_number_at_begin
#define ColumnNEnd me->counter._column_number_at_end
#define ColumnN    me->counter._column_number_at_begin

#   define M     (&TestAnalyzer_M)
#   define M2    (&TestAnalyzer_M2)


    (void)me;
    (void)Indentation;
    (void)Begin;

    TestAnalyzer_IndentationStack*  stack = &me->counter._indentation_stack;
    TestAnalyzer_indentation_t*        start = 0x0;
    ptrdiff_t                     N = (ptrdiff_t)-1;
    size_t                        IndentationStackSize;
    TestAnalyzer_indentation_t*        IndentationStack = &stack->front[0];
    TestAnalyzer_indentation_t         IndentationUpper;
    TestAnalyzer_indentation_t         IndentationLower;
    (void)start;

    __quex_assert((long)Indentation >= 0);

    if( Indentation > *(stack->back) ) {
        ++(stack->back);
        if( stack->back == stack->memory_end ) {
            TestAnalyzer_MF_error_code_set_if_first(me, E_Error_Indentation_StackOverflow);
            return;
        }
        *(stack->back) = Indentation;
self.send(QUEX_TKN_INDENT);
        return;
    }
    else if( Indentation == *(stack->back) ) {
self.send(QUEX_TKN_NODENT);
    }
    else  {
        start = stack->back;
        --(stack->back);
        while( Indentation < *(stack->back) ) {
            --(stack->back);
        }

        N = (ptrdiff_t)(start - stack->back);
        (void)N;
        if( Indentation == *(stack->back) ) { 
            /* 'Landing' must happen on indentation border. */
self.send_n(QUEX_TKN_DEDENT, (size_t)N);

        } else { 
            IndentationStackSize = ((size_t)(1 + start - stack->front));
            IndentationUpper     = stack->back[0];
            IndentationLower     = ((stack->back == stack->front) ? *(stack->front) : *(stack->back - 1));
            (void)IndentationLower;
            (void)IndentationUpper;
            (void)IndentationStack;
            (void)IndentationStackSize;
self.error_code_set_if_first(E_Error_OnIndentationMisfit);

            return;
        }
    }

#   ifdef     self
#       undef self
#   endif


#   undef Lexeme
#   undef LexemeBegin
#   undef LexemeEnd
#   undef LexemeNull
#   undef LexemeL

#undef ColumnN
#undef ColumnNEnd
#undef LineN
#undef LineNEnd

#   undef M
#   undef M2

}

void
TestAnalyzer_M2_on_indentation_bad(TestAnalyzer* me) 
{
#   ifdef     self
#       undef self
#   endif
#   define self (*((TestAnalyzer*)me))


    /* Lexeme setup: 
     *
     * There is a temporary zero stored at the end of each lexeme, if the action 
     * references to the 'Lexeme'. 'LexemeNull' provides a reference to an empty
     * zero terminated string.                                                    */
#if defined(QUEX_OPTION_ASSERTS)
#   define Lexeme       TestAnalyzer_access_Lexeme((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#   define LexemeBegin  TestAnalyzer_access_LexemeBegin((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#   define LexemeL      TestAnalyzer_access_LexemeL((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#   define LexemeEnd    TestAnalyzer_access_LexemeEnd((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#else
#   define Lexeme       (me->buffer._lexeme_start_p)
#   define LexemeBegin  Lexeme
#   define LexemeL      ((size_t)(me->buffer._read_p - me->buffer._lexeme_start_p))
#   define LexemeEnd    me->buffer._read_p
#endif

#define LexemeNull      (&TestAnalyzer_LexemeNull)

#define LineNEnd   me->counter._line_number_at_end
#define LineN      me->counter._line_number_at_begin
#define ColumnNEnd me->counter._column_number_at_end
#define ColumnN    me->counter._column_number_at_begin

#   define M     (&TestAnalyzer_M)
#   define M2    (&TestAnalyzer_M2)

#define BadCharacter  (me->buffer._read_p[-1])

(void)me;

self.error_code_set_if_first(E_Error_OnIndentationBad);


#undef  BadCharacter
#   ifdef     self
#       undef self
#   endif


#   undef Lexeme
#   undef LexemeBegin
#   undef LexemeEnd
#   undef LexemeNull
#   undef LexemeL

#undef ColumnN
#undef ColumnNEnd
#undef LineN
#undef LineNEnd

#   undef M
#   undef M2

}


#ifdef QUEX_OPTION_ASSERTS
bool
TestAnalyzer_M2_has_base(const TestAnalyzer_Mode* Mode) {
    (void)Mode;
return false;
}

bool
TestAnalyzer_M2_has_entry_from(const TestAnalyzer_Mode* Mode) {
    (void)Mode;
if( Mode == &TestAnalyzer_M ) {

    return true;

    }

    else {
    return false;
    }
}

bool
TestAnalyzer_M2_has_exit_to(const TestAnalyzer_Mode* Mode) {
    (void)Mode;
if( Mode == &TestAnalyzer_M ) {

    return true;

    }

    else {
    return false;
    }
}
#endif    

void
TestAnalyzer_M2_on_buffer_before_change(void* me /* 'aux' -> 'self' via 'me' */)
{
#   ifdef     self
#       undef self
#   endif
#   define self (*((TestAnalyzer*)me))


    const TestAnalyzer_lexatom_t* BufferBegin = self.buffer.begin(&self.buffer);
    const TestAnalyzer_lexatom_t* BufferEnd   = self.buffer.end(&self.buffer);
    (void)me; (void)BufferBegin; (void)BufferEnd;

}

inline void
TestAnalyzer_Buffer_print_overflow_message(TestAnalyzer_Buffer* buffer); 

void
TestAnalyzer_M2_on_buffer_overflow(void*  me /* 'aux' -> 'self' via 'me' */)
{
#   ifdef     self
#       undef self
#   endif
#   define self (*((TestAnalyzer*)me))

    const TestAnalyzer_lexatom_t* LexemeBegin = self.buffer._lexeme_start_p;
    const TestAnalyzer_lexatom_t* LexemeEnd   = self.buffer._read_p;
    const size_t             BufferSize  = (size_t)(self.buffer.size(&self.buffer)); 


    /* Try to double the size of the buffer, by default.                      */
    if( ! TestAnalyzer_Buffer_nested_negotiate_extend(&self.buffer, 2.0) ) {
        TestAnalyzer_MF_error_code_set_if_first(&self, E_Error_Buffer_Overflow_LexemeTooLong);
        TestAnalyzer_Buffer_print_overflow_message(&self.buffer);
    }

    (void)me; (void)LexemeBegin; (void)LexemeEnd; (void)BufferSize;
}
#undef self
#undef LexemeNull
#undef FLUSH

static void
TestAnalyzer_M_counter_on_arbitrary_lexeme(TestAnalyzer* me, TestAnalyzer_lexatom_t* LexemeBegin, TestAnalyzer_lexatom_t* LexemeEnd)
{
#   ifdef     self
#       undef self
#   endif
#   define self (*((TestAnalyzer*)me))
/*  'QUEX_GOTO_STATE' requires 'QUEX_LABEL_STATE_ROUTER' */
#   define QUEX_LABEL_STATE_ROUTER _50
    TestAnalyzer_lexatom_t    input                   = (TestAnalyzer_lexatom_t)(0x00);
    TestAnalyzer_goto_label_t target_state_index      = (TestAnalyzer_goto_label_t)-1;
    TestAnalyzer_goto_label_t target_state_else_index = (TestAnalyzer_goto_label_t)-1;
#ifdef QUEX_OPTION_DEBUG_SHOW_EXT
    TestAnalyzer_lexatom_t** position = (TestAnalyzer_lexatom_t**)0;
    const size_t        PositionRegisterN = 0;
#endif
    (void)me;
#ifdef QUEX_OPTION_DEBUG_SHOW_EXT
    (void)position; (void)PositionRegisterN;
#endif
    me->counter._column_number_at_begin = me->counter._column_number_at_end;    me->counter._line_number_at_begin = me->counter._line_number_at_end;    /* Allow LexemeBegin == LexemeEnd (e.g. END_OF_STREAM)
     * => Caller does not need to check
     * BUT, if so quit immediately after 'shift values'.
     */
    __quex_assert(LexemeBegin <= LexemeEnd);
    if( LexemeBegin == LexemeEnd ) {
        return;
    }
    me->buffer._read_p = LexemeBegin;
_33:
    /* (153 from BEFORE_ENTRY)  */
    (me->buffer._lexeme_start_p) = (me->buffer._read_p);

    input = *(me->buffer._read_p);

if( me->buffer._read_p == LexemeEnd ) goto _40;


    __quex_debug_init_state("M:skip", 153);
switch( input ) {
case 0x0: goto _40;
case 0x9: goto _35;
case 0xA: goto _34;
default: goto _36;
}


    __quex_assert_no_passage();
_40:
    /* (DROP_OUT from 153)  */
goto _44;

    __quex_debug(" Drop-Out Catcher\n");


    __quex_assert_no_passage();
_37:
    /* (DROP_OUT from 147)  */
goto _41;


    __quex_assert_no_passage();
_38:
    /* (DROP_OUT from 149)  */
goto _42;


    __quex_assert_no_passage();
_39:
    /* (DROP_OUT from 151)  */
goto _43;


    __quex_assert_no_passage();
_34:
    /* (147 from 153)  */
    ++(me->buffer._read_p);

    input = *(me->buffer._read_p);

if( me->buffer._read_p == LexemeEnd ) goto _37;


    __quex_debug_state(147);
goto _37;


    __quex_assert_no_passage();
_35:
    /* (149 from 153)  */
    ++(me->buffer._read_p);

    input = *(me->buffer._read_p);

if( me->buffer._read_p == LexemeEnd ) goto _38;


    __quex_debug_state(149);
goto _38;


    __quex_assert_no_passage();
_36:
    /* (151 from 153)  */
    ++(me->buffer._read_p);

    input = *(me->buffer._read_p);

if( me->buffer._read_p == LexemeEnd ) goto _39;


    __quex_debug_state(151);
goto _39;

    /* (*) Terminal states _______________________________________________________
     *
     * States that implement actions of the 'winner patterns.                     */
_41:
    __quex_debug("* TERMINAL <TERMINAL column_line_counter (single step)>\n");
    me->counter._line_number_at_end += ((size_t)1); __quex_debug_counter();

    me->counter._column_number_at_end = (1); __quex_debug_counter();
    (me->buffer._lexeme_start_p) = (me->buffer._read_p);

goto _33;

_42:
    __quex_debug("* TERMINAL <TERMINAL column_line_counter (single step)>\n");

self.counter._column_number_at_end -= 1;
self.counter._column_number_at_end &= ~ ((size_t)0x3);
self.counter._column_number_at_end += 4 + 1;


    (me->buffer._lexeme_start_p) = (me->buffer._read_p);

goto _33;

_43:
    __quex_debug("* TERMINAL <TERMINAL column_line_counter (single step)>\n");
    me->counter._column_number_at_end += ((size_t)1); __quex_debug_counter();

    (me->buffer._lexeme_start_p) = (me->buffer._read_p);

goto _33;

_44:
    __quex_debug("* TERMINAL <TERMINAL column_line_counter exit>\n");
goto _32;

if(0) {
    /* Avoid unreferenced labels. */
    goto _41;
    goto _42;
    goto _43;
    goto _44;
}
_52: /* COUNT TERMINAL: BAD_LEXATOM */
;
_51: /* COUNT TERMINAL: FAILURE     */
goto _32;
_32:
/* Assert: lexeme in codec's character boundaries. */

     __quex_assert(me->buffer._read_p == LexemeEnd);
    me->buffer._lexeme_start_p = LexemeBegin;
    return;
    __quex_assert_no_passage();
    goto _50; /* prevent unused label */
_50:

#undef self


#undef QUEX_LABEL_STATE_ROUTER


     goto _50; /* in QUEX_GOTO_STATE       */
     goto _52; /* to BAD_LEXATOM           */

    /* Avoid compiler warning: 'Unused labels' */

    goto _51;
    (void)target_state_index;
    (void)target_state_else_index;
}

#include "test_cpp/lib/buffer/Buffer"
#include "test_cpp/lib/token/TokenQueue"

#ifdef    CONTINUE
#   undef CONTINUE
#endif
#define   CONTINUE do { goto _64; } while(0)

#ifdef    FLUSH
#   undef FLUSH
#endif
#define   FLUSH   do { goto _63; } while(0)

void  
TestAnalyzer_M_analyzer_function(TestAnalyzer* me) 
{
    /* NOTE: Different modes correspond to different analyzer functions. The 
     *       analyzer functions are all located inside the main class as static
     *       functions. That means, they are something like 'globals'. They 
     *       receive a pointer to the lexical analyzer, since static members do
     *       not have access to the 'this' pointer.                          */
#   ifdef     self
#       undef self
#   endif
#   define self (*((TestAnalyzer*)me))
#   define M     (&TestAnalyzer_M)
#   define M2    (&TestAnalyzer_M2)
/*  'QUEX_GOTO_STATE' requires 'QUEX_LABEL_STATE_ROUTER' */
#   define QUEX_LABEL_STATE_ROUTER _67

    /* Lexeme setup: 
     *
     * There is a temporary zero stored at the end of each lexeme, if the action 
     * references to the 'Lexeme'. 'LexemeNull' provides a reference to an empty
     * zero terminated string.                                                    */
#if defined(QUEX_OPTION_ASSERTS)
#   define Lexeme       TestAnalyzer_access_Lexeme((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#   define LexemeBegin  TestAnalyzer_access_LexemeBegin((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#   define LexemeL      TestAnalyzer_access_LexemeL((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#   define LexemeEnd    TestAnalyzer_access_LexemeEnd((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#else
#   define Lexeme       (me->buffer._lexeme_start_p)
#   define LexemeBegin  Lexeme
#   define LexemeL      ((size_t)(me->buffer._read_p - me->buffer._lexeme_start_p))
#   define LexemeEnd    me->buffer._read_p
#endif

#define LexemeNull      (&TestAnalyzer_LexemeNull)
#define LineNEnd   me->counter._line_number_at_end
#define LineN      me->counter._line_number_at_begin
#define ColumnNEnd me->counter._column_number_at_end
#define ColumnN    me->counter._column_number_at_begin
    TestAnalyzer_lexatom_t    input                   = (TestAnalyzer_lexatom_t)(0x00);
    TestAnalyzer_lexatom_t**  position                = 0x0;
    const size_t         PositionRegisterN       = (size_t)0;
    TestAnalyzer_goto_label_t target_state_else_index = (TestAnalyzer_goto_label_t)-1;
    TestAnalyzer_goto_label_t target_state_index      = (TestAnalyzer_goto_label_t)-1;
    E_LoadResult         load_result             = E_LoadResult_VOID;

    /* Post context positions do not have to be reset or initialized. If a state
     * is reached which is associated with 'end of post context' it is clear what
     * post context is meant. This results from the ways the state machine is 
     * constructed. Post context position's live cycle:
     *
     * (1)   unitialized (don't care)
     * (1.b) on buffer reload it may, or may not be adapted (don't care)
     * (2)   when a post context begin state is passed, then it is **SET** (now: take care)
     * (2.b) on buffer reload it **is adapted**.
     * (3)   when a terminal state of the post context is reached (which can only be reached
     *       for that particular post context), then the post context position is used
     *       to reset the input position.                                              */
#   if defined(QUEX_OPTION_ASSERTS)
    me->DEBUG_analyzer_function_at_entry = me->current_analyzer_function;
#   endif
_66:
    me->buffer._lexeme_start_p = me->buffer._read_p;
    QUEX_TestAnalyzer_LEXEME_TERMINATING_ZERO_UNDO(&me->buffer);
_53:
    /* (165 from BEFORE_ENTRY) (165 from RELOAD_FORWARD)  */

    input = *(me->buffer._read_p);


    __quex_debug_init_state("M:Core", 165);
if     ( input == 0x58 )  goto _54;
else if( input == 0x0 )   goto _57;
else                      goto _55;


    __quex_assert_no_passage();
_56:
    /* (DROP_OUT from 166)  */
goto _0;
_60:
    __quex_debug(" Drop-Out Catcher\n");


    __quex_assert_no_passage();
_55:
    /* (DROP_OUT from 165)  */
    me->buffer._read_p = me->buffer._lexeme_start_p + 1;
goto _2;
    goto _60;


    __quex_assert_no_passage();
_54:
    /* (166 from 165)  */
    ++(me->buffer._read_p);

    input = *(me->buffer._read_p);


    __quex_debug_state(166);
goto _56;

    /* (*) Terminal states _______________________________________________________
     *
     * States that implement actions of the 'winner patterns.                     */
_0:
    __quex_debug("* TERMINAL X\n");
    me->counter._column_number_at_begin = me->counter._column_number_at_end;
    me->counter._line_number_at_begin = me->counter._line_number_at_end;
    me->counter._column_number_at_end += ((size_t)1); __quex_debug_counter();

    me->buffer._lexatom_before_lexeme_start = *(me->buffer._read_p - 1);
{

#   line 3 "nothing.qx"
self.send(QUEX_TKN_X);
return;

#   line 753 "test_cpp/TestAnalyzer.cpp"

}
FLUSH;
_1:
    __quex_debug("* TERMINAL BAD_LEXATOM\n");
TestAnalyzer_M_counter_on_arbitrary_lexeme((TestAnalyzer*)me, LexemeBegin, (me->buffer._read_p));

    me->buffer._lexatom_before_lexeme_start = *(me->buffer._read_p - 1);
{
#define BadLexatom ((me->buffer._read_p > me->buffer._memory._front && me->buffer._read_p <= me->buffer.input.end_p) ? (me->buffer._read_p[-1]) : (TestAnalyzer_lexatom_t)-1)
self.error_code_set_if_first(E_Error_OnBadLexatom);
self.send(QUEX_TKN_TERMINATION);
return;
#undef BadLexatom

}
    /* Bad lexatom detection FORCES a return from the lexical analyzer, so that no
     * tokens can be filled after the termination token.
     */
return;
_5:
    __quex_debug("* TERMINAL END_OF_STREAM\n");
TestAnalyzer_M_counter_on_arbitrary_lexeme((TestAnalyzer*)me, LexemeBegin, (me->buffer._read_p));

    me->buffer._lexatom_before_lexeme_start = *(me->buffer._read_p - 1);
{
self.send(QUEX_TKN_TERMINATION);
return;

}
    /* End of Stream FORCES a return from the lexical analyzer, so that no
     * tokens can be filled after the termination token.
     */
return;
_3:
    __quex_debug("* TERMINAL LOAD_FAILURE\n");
TestAnalyzer_M_counter_on_arbitrary_lexeme((TestAnalyzer*)me, LexemeBegin, (me->buffer._read_p));

    me->buffer._lexatom_before_lexeme_start = *(me->buffer._read_p - 1);
{
self.error_code_set_if_first(E_Error_OnLoadFailure);
self.send(QUEX_TKN_TERMINATION);
return;

}
    /* Load failure FORCES a return from the lexical analyzer, so that no
     * tokens can be filled after the termination token.
     */
return;
_2:
    __quex_debug("* TERMINAL FAILURE\n");
TestAnalyzer_M_counter_on_arbitrary_lexeme((TestAnalyzer*)me, LexemeBegin, (me->buffer._read_p));

    me->buffer._lexatom_before_lexeme_start = *(me->buffer._read_p - 1);
{
self.error_code_set_if_first(E_Error_OnFailure);
self.send(QUEX_TKN_TERMINATION);
return;

}
return;
_4:
    __quex_debug("* TERMINAL SKIP_RANGE_OPEN\n");
TestAnalyzer_M_counter_on_arbitrary_lexeme((TestAnalyzer*)me, LexemeBegin, (me->buffer._read_p));

    me->buffer._lexatom_before_lexeme_start = *(me->buffer._read_p - 1);
{
#define Counter counter
self.error_code_set_if_first(E_Error_OnSkipRangeOpen);
self.send(QUEX_TKN_TERMINATION);
return;

}
    /* End of Stream appeared, while scanning for end of skip-range.
     */
return;
if(0) {
    /* Avoid unreferenced labels. */
    goto _0;
    goto _1;
    goto _5;
    goto _3;
    goto _2;
    goto _4;
}
    __quex_assert_no_passage();
    goto _67; /* prevent unused label */
_67:
switch( target_state_index ) {
case 5: {
goto _5;}
case 53: {
goto _53;}
default: {
goto _53;}
}


    __quex_assert_no_passage();
_57:
    /* (RELOAD_FORWARD from 165)  */
    target_state_index = 53; target_state_else_index = 5;

if( me->buffer._read_p != (me->buffer.input.end_p) ) goto _55;



    __quex_debug3("RELOAD_FORWARD: success->%i; failure->%i", 
                  (int)target_state_index, (int)target_state_else_index);
    __quex_assert(*(me->buffer._read_p) == QUEX_TestAnalyzer_SETTING_BUFFER_LEXATOM_BUFFER_BORDER);
    
    __quex_debug_reload_before();                 
    /* Callbacks: 'on_buffer_before_change()' and 'on_buffer_overflow()'
     * are called during load process upon occurrence.                        */
    load_result = TestAnalyzer_Buffer_load_forward(&me->buffer, (TestAnalyzer_lexatom_t**)position, PositionRegisterN);
    __quex_debug_reload_after(load_result);

    switch( load_result ) {
    case E_LoadResult_DONE: {
        /* FallbackN must be maintained at any cost!                          */
        __quex_assert(   ! me->buffer.input.lexatom_index_begin
                      || ! me->buffer._lexeme_start_p
                      ||   me->buffer._lexeme_start_p - me->buffer.content_begin(&me->buffer) >= me->buffer._fallback_n);
        __quex_assert(   ! me->buffer.input.lexatom_index_begin
                      || ! me->buffer._read_p
                      ||   me->buffer._read_p        - me->buffer.content_begin(&me->buffer) >= me->buffer._fallback_n);
        { target_state_index = target_state_index; goto QUEX_LABEL_STATE_ROUTER; }      
    }
    case E_LoadResult_NO_MORE_DATA:   { target_state_index = target_state_else_index; goto QUEX_LABEL_STATE_ROUTER; } 
    case E_LoadResult_ENCODING_ERROR: goto _1;
    case E_LoadResult_OVERFLOW:       TestAnalyzer_MF_error_code_set_if_first(me, E_Error_Buffer_Overflow_LexemeTooLong); FLUSH;
    default:                          __quex_assert(false);
    }

_63:
/* FLUSH: return after executing 'on_after_match' code. */
    return;


_64:
/* CONTINUE -- after executing 'on_after_match' code. */

_65:
/* CONTINUE -- without executing 'on_after_match' (e.g. on FAILURE). */


    /* Mode change = another function takes over the analysis.
     * => After mode change the analyzer function needs to be quit!
     * ASSERT: 'CONTINUE' after mode change is not allowed.                   */
    __quex_assert(   me->DEBUG_analyzer_function_at_entry 
                  == me->current_analyzer_function);


    if( TestAnalyzer_TokenQueue_is_full(&self._token_queue) ) {
        return;
    }


goto _66;

    __quex_assert_no_passage();

    /* Following labels are referenced in macros. It cannot be detected
     * whether the macros are applied in user code or not. To avoid compiler.
     * warnings of unused labels, they are referenced in unreachable code.   */
    goto _63; /* in FLUSH                 */
    goto _64; /* in CONTINUE              */
    goto _65; /* in CONTINUE and skippers */

    goto _67; /* in QUEX_GOTO_STATE       */


    /* Prevent compiler warning 'unused variable'.                           */
    (void)TestAnalyzer_LexemeNull;
    /* target_state_index and target_state_else_index appear when 
     * QUEX_GOTO_STATE is used without computed goto-s.                      */
    (void)target_state_index;
    (void)target_state_else_index;

#   undef Lexeme
#   undef LexemeBegin
#   undef LexemeEnd
#   undef LexemeNull
#   undef LexemeL
#undef ColumnN
#undef ColumnNEnd
#undef LineN
#undef LineNEnd
#   undef M
#   undef M2
#   undef self
#   undef QUEX_LABEL_STATE_ROUTER
}
static void
TestAnalyzer_M2_counter_on_arbitrary_lexeme(TestAnalyzer* me, TestAnalyzer_lexatom_t* LexemeBegin, TestAnalyzer_lexatom_t* LexemeEnd)
{
(void)me; (void)LexemeBegin; (void)LexemeEnd;
TestAnalyzer_M_counter_on_arbitrary_lexeme((TestAnalyzer*)me, LexemeBegin, (me->buffer._read_p));
}

#include "test_cpp/lib/buffer/Buffer"
#include "test_cpp/lib/token/TokenQueue"

#ifdef    CONTINUE
#   undef CONTINUE
#endif
#define   CONTINUE do { goto _100; } while(0)

#ifdef    FLUSH
#   undef FLUSH
#endif
#define   FLUSH   do { goto _99; } while(0)

void  
TestAnalyzer_M2_analyzer_function(TestAnalyzer* me) 
{
    /* NOTE: Different modes correspond to different analyzer functions. The 
     *       analyzer functions are all located inside the main class as static
     *       functions. That means, they are something like 'globals'. They 
     *       receive a pointer to the lexical analyzer, since static members do
     *       not have access to the 'this' pointer.                          */
#   ifdef     self
#       undef self
#   endif
#   define self (*((TestAnalyzer*)me))
#   define M     (&TestAnalyzer_M)
#   define M2    (&TestAnalyzer_M2)
/*  'QUEX_GOTO_STATE' requires 'QUEX_LABEL_STATE_ROUTER' */
#   define QUEX_LABEL_STATE_ROUTER _102

    /* Lexeme setup: 
     *
     * There is a temporary zero stored at the end of each lexeme, if the action 
     * references to the 'Lexeme'. 'LexemeNull' provides a reference to an empty
     * zero terminated string.                                                    */
#if defined(QUEX_OPTION_ASSERTS)
#   define Lexeme       TestAnalyzer_access_Lexeme((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#   define LexemeBegin  TestAnalyzer_access_LexemeBegin((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#   define LexemeL      TestAnalyzer_access_LexemeL((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#   define LexemeEnd    TestAnalyzer_access_LexemeEnd((const char*)__FILE__, (size_t)__LINE__, &me->buffer)
#else
#   define Lexeme       (me->buffer._lexeme_start_p)
#   define LexemeBegin  Lexeme
#   define LexemeL      ((size_t)(me->buffer._read_p - me->buffer._lexeme_start_p))
#   define LexemeEnd    me->buffer._read_p
#endif

#define LexemeNull      (&TestAnalyzer_LexemeNull)
#define LineNEnd   me->counter._line_number_at_end
#define LineN      me->counter._line_number_at_begin
#define ColumnNEnd me->counter._column_number_at_end
#define ColumnN    me->counter._column_number_at_begin
    TestAnalyzer_lexatom_t    input                   = (TestAnalyzer_lexatom_t)(0x00);
    TestAnalyzer_lexatom_t**  position                = 0x0;
    const size_t         PositionRegisterN       = (size_t)0;
    TestAnalyzer_goto_label_t target_state_else_index = (TestAnalyzer_goto_label_t)-1;
    TestAnalyzer_goto_label_t target_state_index      = (TestAnalyzer_goto_label_t)-1;
    E_LoadResult         load_result             = E_LoadResult_VOID;

    /* Post context positions do not have to be reset or initialized. If a state
     * is reached which is associated with 'end of post context' it is clear what
     * post context is meant. This results from the ways the state machine is 
     * constructed. Post context position's live cycle:
     *
     * (1)   unitialized (don't care)
     * (1.b) on buffer reload it may, or may not be adapted (don't care)
     * (2)   when a post context begin state is passed, then it is **SET** (now: take care)
     * (2.b) on buffer reload it **is adapted**.
     * (3)   when a terminal state of the post context is reached (which can only be reached
     *       for that particular post context), then the post context position is used
     *       to reset the input position.                                              */
#   if defined(QUEX_OPTION_ASSERTS)
    me->DEBUG_analyzer_function_at_entry = me->current_analyzer_function;
#   endif
_101:
    me->buffer._lexeme_start_p = me->buffer._read_p;
    QUEX_TestAnalyzer_LEXEME_TERMINATING_ZERO_UNDO(&me->buffer);
_68:
    /* (173 from BEFORE_ENTRY) (173 from RELOAD_FORWARD)  */

    input = *(me->buffer._read_p);


    __quex_debug_init_state("M2:Core", 173);
switch( input ) {
case 0x0: goto _77;
case 0xA: goto _69;
case 0xD: goto _70;
case 0x58: goto _71;
default: goto _73;
}


    __quex_assert_no_passage();
_74:
    /* (DROP_OUT from 172)  */
if( (me->buffer._lexatom_before_lexeme_start == '\n') || (TestAnalyzer_Buffer_is_begin_of_stream(&me->buffer)) ) {
goto _27;
}

_81:
    me->buffer._read_p = me->buffer._lexeme_start_p + 1;
goto _29;

    __quex_debug(" Drop-Out Catcher\n");


    __quex_assert_no_passage();
_72:
    /* (DROP_OUT from 169)  */
goto _26;


    __quex_assert_no_passage();
_73:
    /* (DROP_OUT from 170) (DROP_OUT from 173)  */
    goto _81;


    __quex_assert_no_passage();
_69:
    /* (169 from 170) (169 from 173)  */

    ++(me->buffer._read_p);

    input = *(me->buffer._read_p);


    __quex_debug_state(169);
goto _72;


    __quex_assert_no_passage();
_75:
    /* (170 from RELOAD_FORWARD)  */
_85:
    input = *(me->buffer._read_p);


    __quex_debug_state(170);
if     ( input == 0xA )  goto _69;
else if( input == 0x0 )  goto _76;
else                     goto _73;


    __quex_assert_no_passage();
_70:
    /* (170 from 173)  */
    ++(me->buffer._read_p);

    goto _85;


    __quex_assert_no_passage();
_71:
    /* (172 from 173)  */
    ++(me->buffer._read_p);

    input = *(me->buffer._read_p);


    __quex_debug_state(172);
goto _74;
_7:
    /* (88 from BEFORE_ENTRY)  */
    (me->buffer._lexeme_start_p) = (me->buffer._read_p);

_88:
    input = *(me->buffer._read_p);


    __quex_debug_init_state("M2:Extra", 88);
switch( input ) {
case 0x0: goto _14;
case 0x9: 
case 0x20: goto _10;
default: goto _11;
}


    __quex_assert_no_passage();
_12:
    /* (88 from RELOAD_FORWARD)  */
    goto _88;


    __quex_assert_no_passage();
_10:
    /* (88 from 88)  */
    ++(me->buffer._read_p);

    goto _88;


    __quex_assert_no_passage();
_11:
    /* (DROP_OUT from 88)  */
goto _23;

    __quex_debug(" Drop-Out Catcher\n");
_8:
    /* (92 from BEFORE_ENTRY) (92 from RELOAD_FORWARD)  */

    input = *(me->buffer._read_p);


    __quex_debug_init_state("M2:Extra", 92);
switch( input ) {
case 0x0: goto _20;
case 0xA: goto _15;
case 0xD: goto _16;
default: goto _17;
}


    __quex_assert_no_passage();
_19:
    /* (DROP_OUT from 94)  */
    me->buffer._read_p -= 1;
goto _24;

    __quex_debug(" Drop-Out Catcher\n");


    __quex_assert_no_passage();
_17:
    /* (DROP_OUT from 92)  */
goto _24;


    __quex_assert_no_passage();
_18:
    /* (DROP_OUT from 93)  */
goto _25;


    __quex_assert_no_passage();
_15:
    /* (93 from 92) (93 from 94)  */

    ++(me->buffer._read_p);

    input = *(me->buffer._read_p);


    __quex_debug_state(93);
goto _18;


    __quex_assert_no_passage();
_21:
    /* (94 from RELOAD_FORWARD)  */
_96:
    input = *(me->buffer._read_p);


    __quex_debug_state(94);
if     ( input == 0xA )  goto _15;
else if( input == 0x0 )  goto _22;
else                     goto _19;


    __quex_assert_no_passage();
_16:
    /* (94 from 92)  */
    ++(me->buffer._read_p);

    goto _96;

    /* (*) Terminal states _______________________________________________________
     *
     * States that implement actions of the 'winner patterns.                     */
_23:
    __quex_debug("* TERMINAL <whitespace>\n");
TestAnalyzer_M2_counter_on_arbitrary_lexeme((TestAnalyzer*)me, LexemeBegin, (me->buffer._read_p));

    (me->buffer._lexeme_start_p) = (me->buffer._read_p);

goto _8;

_24:
    __quex_debug("* TERMINAL <accept_on_nothing>\n");
    TestAnalyzer_M2_on_indentation(me, (TestAnalyzer_indentation_t)me->counter._column_number_at_end, LexemeNull);

    (me->buffer._lexeme_start_p) = (me->buffer._read_p);

goto _9;

_25:
    __quex_debug("* TERMINAL <newline>\n");
TestAnalyzer_M2_counter_on_arbitrary_lexeme((TestAnalyzer*)me, LexemeBegin, (me->buffer._read_p));

goto _7;

_27:
    __quex_debug("* TERMINAL ^X\n");
    me->counter._column_number_at_begin = me->counter._column_number_at_end;
    me->counter._line_number_at_begin = me->counter._line_number_at_end;
    me->counter._column_number_at_end = (2); __quex_debug_counter();
    me->buffer._lexatom_before_lexeme_start = *(me->buffer._read_p - 1);
{

#   line 4 "nothing.qx"
self.send(QUEX_TKN_X);
return;

#   line 1260 "test_cpp/TestAnalyzer.cpp"

}
FLUSH;
_28:
    __quex_debug("* TERMINAL BAD_LEXATOM\n");
TestAnalyzer_M2_counter_on_arbitrary_lexeme((TestAnalyzer*)me, LexemeBegin, (me->buffer._read_p));

    TestAnalyzer_M2_on_indentation(me, (TestAnalyzer_indentation_t)me->counter._column_number_at_end, LexemeNull);
    me->buffer._lexatom_before_lexeme_start = *(me->buffer._read_p - 1);
{
#define BadLexatom ((me->buffer._read_p > me->buffer._memory._front && me->buffer._read_p <= me->buffer.input.end_p) ? (me->buffer._read_p[-1]) : (TestAnalyzer_lexatom_t)-1)
self.error_code_set_if_first(E_Error_OnBadLexatom);
self.send(QUEX_TKN_TERMINATION);
return;
#undef BadLexatom

}
    /* Bad lexatom detection FORCES a return from the lexical analyzer, so that no
     * tokens can be filled after the termination token.
     */
return;
_13:
    __quex_debug("* TERMINAL END_OF_STREAM\n");
TestAnalyzer_M2_counter_on_arbitrary_lexeme((TestAnalyzer*)me, LexemeBegin, (me->buffer._read_p));

    TestAnalyzer_M2_on_indentation(me, (TestAnalyzer_indentation_t)me->counter._column_number_at_end, LexemeNull);
    me->buffer._lexatom_before_lexeme_start = *(me->buffer._read_p - 1);
{
self.send(QUEX_TKN_TERMINATION);
return;

}
    /* End of Stream FORCES a return from the lexical analyzer, so that no
     * tokens can be filled after the termination token.
     */
return;
_26:
    __quex_debug("* TERMINAL <indentation handler>\n");
    me->counter._column_number_at_begin = me->counter._column_number_at_end;
    me->counter._line_number_at_begin = me->counter._line_number_at_end;
    me->counter._line_number_at_end += ((size_t)1); __quex_debug_counter();

    me->counter._column_number_at_end = (1); __quex_debug_counter();
goto _7;

_30:
    __quex_debug("* TERMINAL LOAD_FAILURE\n");
TestAnalyzer_M2_counter_on_arbitrary_lexeme((TestAnalyzer*)me, LexemeBegin, (me->buffer._read_p));

    TestAnalyzer_M2_on_indentation(me, (TestAnalyzer_indentation_t)me->counter._column_number_at_end, LexemeNull);
    me->buffer._lexatom_before_lexeme_start = *(me->buffer._read_p - 1);
{
self.error_code_set_if_first(E_Error_OnLoadFailure);
self.send(QUEX_TKN_TERMINATION);
return;

}
    /* Load failure FORCES a return from the lexical analyzer, so that no
     * tokens can be filled after the termination token.
     */
return;
_29:
    __quex_debug("* TERMINAL FAILURE\n");
TestAnalyzer_M2_counter_on_arbitrary_lexeme((TestAnalyzer*)me, LexemeBegin, (me->buffer._read_p));

    me->buffer._lexatom_before_lexeme_start = *(me->buffer._read_p - 1);
{
self.error_code_set_if_first(E_Error_OnFailure);
self.send(QUEX_TKN_TERMINATION);
return;

}
return;
_31:
    __quex_debug("* TERMINAL SKIP_RANGE_OPEN\n");
TestAnalyzer_M2_counter_on_arbitrary_lexeme((TestAnalyzer*)me, LexemeBegin, (me->buffer._read_p));

    TestAnalyzer_M2_on_indentation(me, (TestAnalyzer_indentation_t)me->counter._column_number_at_end, LexemeNull);
    me->buffer._lexatom_before_lexeme_start = *(me->buffer._read_p - 1);
{
#define Counter counter
self.error_code_set_if_first(E_Error_OnSkipRangeOpen);
self.send(QUEX_TKN_TERMINATION);
return;

}
    /* End of Stream appeared, while scanning for end of skip-range.
     */
return;
if(0) {
    /* Avoid unreferenced labels. */
    goto _23;
    goto _24;
    goto _25;
    goto _27;
    goto _28;
    goto _13;
    goto _26;
    goto _30;
    goto _29;
    goto _31;
}
    __quex_assert_no_passage();
    goto _102; /* prevent unused label */
_102:
switch( target_state_index ) {
case 8: {
goto _8;}
case 12: {
goto _12;}
case 13: {
goto _13;}
case 19: {
goto _19;}
case 21: {
goto _21;}
case 68: {
goto _68;}
case 73: {
goto _73;}
case 75: {
goto _75;}
default: {
goto _75;}
}


    __quex_assert_no_passage();
_77:
    /* (RELOAD_FORWARD from 173)  */
    target_state_index = 68; target_state_else_index = 13;

_98:
if( me->buffer._read_p != (me->buffer.input.end_p) ) goto _73;

_97:

    __quex_debug3("RELOAD_FORWARD: success->%i; failure->%i", 
                  (int)target_state_index, (int)target_state_else_index);
    __quex_assert(*(me->buffer._read_p) == QUEX_TestAnalyzer_SETTING_BUFFER_LEXATOM_BUFFER_BORDER);
    
    __quex_debug_reload_before();                 
    /* Callbacks: 'on_buffer_before_change()' and 'on_buffer_overflow()'
     * are called during load process upon occurrence.                        */
    load_result = TestAnalyzer_Buffer_load_forward(&me->buffer, (TestAnalyzer_lexatom_t**)position, PositionRegisterN);
    __quex_debug_reload_after(load_result);

    switch( load_result ) {
    case E_LoadResult_DONE: {
        /* FallbackN must be maintained at any cost!                          */
        __quex_assert(   ! me->buffer.input.lexatom_index_begin
                      || ! me->buffer._lexeme_start_p
                      ||   me->buffer._lexeme_start_p - me->buffer.content_begin(&me->buffer) >= me->buffer._fallback_n);
        __quex_assert(   ! me->buffer.input.lexatom_index_begin
                      || ! me->buffer._read_p
                      ||   me->buffer._read_p        - me->buffer.content_begin(&me->buffer) >= me->buffer._fallback_n);
        { target_state_index = target_state_index; goto QUEX_LABEL_STATE_ROUTER; }      
    }
    case E_LoadResult_NO_MORE_DATA:   { target_state_index = target_state_else_index; goto QUEX_LABEL_STATE_ROUTER; } 
    case E_LoadResult_ENCODING_ERROR: goto _28;
    case E_LoadResult_OVERFLOW:       TestAnalyzer_MF_error_code_set_if_first(me, E_Error_Buffer_Overflow_LexemeTooLong); FLUSH;
    default:                          __quex_assert(false);
    }


    __quex_assert_no_passage();
_76:
    /* (RELOAD_FORWARD from 170)  */
    target_state_index = 75; target_state_else_index = 73;

    goto _98;


    __quex_assert_no_passage();
_20:
    /* (RELOAD_FORWARD from 92)  */
    target_state_index = 8; target_state_else_index = 13;

if( me->buffer._read_p != (me->buffer.input.end_p) ) goto _17;

    goto _97;


    __quex_assert_no_passage();
_22:
    /* (RELOAD_FORWARD from 94)  */
    target_state_index = 21; target_state_else_index = 19;

if( me->buffer._read_p != (me->buffer.input.end_p) ) goto _19;

    goto _97;


    __quex_assert_no_passage();
_14:
    /* (RELOAD_FORWARD from 88)  */
    target_state_index = 12; target_state_else_index = 13;

if( me->buffer._read_p != (me->buffer.input.end_p) ) goto _11;

TestAnalyzer_M2_counter_on_arbitrary_lexeme((TestAnalyzer*)me, LexemeBegin, (me->buffer._read_p));

    (me->buffer._lexeme_start_p) = (me->buffer._read_p);

    goto _97;

_99:
/* FLUSH: return after executing 'on_after_match' code. */
    return;


_100:
/* CONTINUE -- after executing 'on_after_match' code. */

_9:
/* CONTINUE -- without executing 'on_after_match' (e.g. on FAILURE). */


    /* Mode change = another function takes over the analysis.
     * => After mode change the analyzer function needs to be quit!
     * ASSERT: 'CONTINUE' after mode change is not allowed.                   */
    __quex_assert(   me->DEBUG_analyzer_function_at_entry 
                  == me->current_analyzer_function);


    if( TestAnalyzer_TokenQueue_is_full(&self._token_queue) ) {
        return;
    }


goto _101;

    __quex_assert_no_passage();

    /* Following labels are referenced in macros. It cannot be detected
     * whether the macros are applied in user code or not. To avoid compiler.
     * warnings of unused labels, they are referenced in unreachable code.   */
    goto _99; /* in FLUSH                 */
    goto _100; /* in CONTINUE              */
    goto _9; /* in CONTINUE and skippers */

    goto _102; /* in QUEX_GOTO_STATE       */


    /* Prevent compiler warning 'unused variable'.                           */
    (void)TestAnalyzer_LexemeNull;
    /* target_state_index and target_state_else_index appear when 
     * QUEX_GOTO_STATE is used without computed goto-s.                      */
    (void)target_state_index;
    (void)target_state_else_index;

#   undef Lexeme
#   undef LexemeBegin
#   undef LexemeEnd
#   undef LexemeNull
#   undef LexemeL
#undef ColumnN
#undef ColumnNEnd
#undef LineN
#undef LineNEnd
#   undef M
#   undef M2
#   undef self
#   undef QUEX_LABEL_STATE_ROUTER
}


#include "test_cpp/TestAnalyzer-token_ids"





bool
TestAnalyzer_user_constructor(TestAnalyzer* me)
{
    (void)me;

#define self  (*(TestAnalyzer*)me)
/* START: User's constructor extensions _______________________________________*/
return UserConstructor_UnitTest_return_value;
/* END: _______________________________________________________________________*/
#undef self
    return true;
}

void
TestAnalyzer_user_destructor(TestAnalyzer* me)
{
    (void)me;

#define self  (*(TestAnalyzer*)me)
/* START: User's constructor extensions _______________________________________*/

/* END: _______________________________________________________________________*/
#undef self
}

bool
TestAnalyzer_user_reset(TestAnalyzer* me)
{
    (void)me;

#define self  (*(TestAnalyzer*)me)
/* START: User's 'reset' ______________________________________________________*/
return UserReset_UnitTest_return_value;
/* END: _______________________________________________________________________*/
#undef self
    return true;
}

void
TestAnalyzer_user_print(TestAnalyzer* me)
{
    (void)me;

#define self  (*(TestAnalyzer*)me)
/* START: User's constructor extensions _______________________________________*/

/* END: _______________________________________________________________________*/
#undef self
}

bool
TestAnalyzer_user_memento_pack(TestAnalyzer* me, 
                             const char*         InputName, 
                             TestAnalyzer_Memento* memento) 
{
    (void)me; (void)memento; (void)InputName;

#define self  (*(TestAnalyzer*)me)
/* START: User's memento 'pack' _______________________________________________*/
return UserMementoPack_UnitTest_return_value;
/* END: _______________________________________________________________________*/
#undef self
    return true;
}

void
TestAnalyzer_user_memento_unpack(TestAnalyzer*  me, 
                               TestAnalyzer_Memento*  memento)
{
    (void)me; (void)memento;

#define self  (*(TestAnalyzer*)me)
/* START: User's memento 'unpack' _____________________________________________*/

/* END: _______________________________________________________________________*/
#undef self
}

const char*
TestAnalyzer_map_token_id_to_name(const TestAnalyzer_token_id_t TokenID)
/* NOTE: This function is not element of the token namespace, since the token
 *       identifiers are lied to the generated lexical analyzer. The token class
 *       may be used over multiple lexical analyzers.                         */
{
   switch( TokenID ) {
   default: {
       return "<NUMERIC VALUE OF TOKEN-ID UNDEFINED>";
   }

   case QUEX_TKN_TERMINATION:    return "<TERMINATION>";
   case QUEX_TKN_UNINITIALIZED:  return "<UNINITIALIZED>";

   case QUEX_TKN_INDENT:         return "<INDENT>";
   case QUEX_TKN_DEDENT:         return "<DEDENT>";
   case QUEX_TKN_NODENT:         return "<NODENT>";

   case QUEX_TKN_X:             return "X";


   }
}







bool UserConstructor_UnitTest_return_value = true;
bool UserReset_UnitTest_return_value       = true;
bool UserMementoPack_UnitTest_return_value = true;
