/* -*- C++ -*- vim: set syntax=cpp:
 * (C) 2005-2010 Frank-Rene Schaefer
 * ABSOLUTELY NO WARRANTY              */
#ifndef QUEX_INCLUDE_GUARD_TestAnalyzer__ANALYZER__MEMBER__NAVIGATION_I
#define QUEX_INCLUDE_GUARD_TestAnalyzer__ANALYZER__MEMBER__NAVIGATION_I

#include "test_cpp_cg/lib/definitions"



inline QUEX_TYPE_STREAM_POSITION  
TestAnalyzer_MF_tell(TestAnalyzer* me)
{
    /* No 'undo terminating zero' -- we do not change the lexeme pointer here. */
    return (QUEX_TYPE_STREAM_POSITION)TestAnalyzer_Buffer_tell(&me->buffer);
}

inline void    
TestAnalyzer_MF_seek(TestAnalyzer* me, const QUEX_TYPE_STREAM_POSITION CharacterIndex)
{
    QUEX_TestAnalyzer_LEXEME_TERMINATING_ZERO_UNDO(&me->buffer);
    TestAnalyzer_Buffer_seek(&me->buffer, (ptrdiff_t)CharacterIndex);
}

inline void    
TestAnalyzer_MF_seek_forward(TestAnalyzer* me, ptrdiff_t LexatomN)
{
    QUEX_TestAnalyzer_LEXEME_TERMINATING_ZERO_UNDO(&me->buffer);
    TestAnalyzer_Buffer_seek_forward(&me->buffer, (ptrdiff_t)LexatomN);
}

inline void    
TestAnalyzer_MF_seek_backward(TestAnalyzer* me, ptrdiff_t LexatomN)
{
    QUEX_TestAnalyzer_LEXEME_TERMINATING_ZERO_UNDO(&me->buffer);
    TestAnalyzer_Buffer_seek_backward(&me->buffer, (ptrdiff_t)LexatomN);
}

inline void  
TestAnalyzer_MF_undo(TestAnalyzer* me)
{
       me->counter._line_number_at_end   = me->counter._line_number_at_begin;
     me->counter._column_number_at_end = me->counter._column_number_at_begin;

    QUEX_TestAnalyzer_LEXEME_TERMINATING_ZERO_UNDO(&me->buffer);

    me->buffer._read_p = me->buffer._lexeme_start_p;

    QUEX_TestAnalyzer_LEXEME_TERMINATING_ZERO_SET(&me->buffer);
}

inline void  
TestAnalyzer_MF_undo_n(TestAnalyzer* me, ptrdiff_t DeltaN_Backward)
{
       me->counter._line_number_at_end   = me->counter._line_number_at_begin;
     me->counter._column_number_at_end = me->counter._column_number_at_begin;

    QUEX_TestAnalyzer_LEXEME_TERMINATING_ZERO_UNDO(&me->buffer);

    me->buffer._read_p -= (ptrdiff_t)DeltaN_Backward;

    QUEX_TestAnalyzer_LEXEME_TERMINATING_ZERO_SET(&me->buffer);

    __quex_assert(me->buffer._read_p >= me->buffer._lexeme_start_p);
}



#endif /* QUEX_INCLUDE_GUARD_TestAnalyzer__ANALYZER__MEMBER__NAVIGATION_I */
