#ifndef QUEX_INCLUDE_GUARD_TestAnalyzer__ANALYZER__STATISTICS_I
#define QUEX_INCLUDE_GUARD_TestAnalyzer__ANALYZER__STATISTICS_I

#include "test_cpp_emm/lib/analyzer/Statistics"




#define __QUEX_STD_fopen std::fopen



inline void
TestAnalyzer_statistics_state_count(const TestAnalyzer_statistics_state* S, TestAnalyzer_lexatom_t C)
{
    const TestAnalyzer_lexatom_t*  BeginP   = S->interval_list.boundary;
    const TestAnalyzer_lexatom_t*  EndP     = BeginP + S->interval_list.boundary_n;
    const TestAnalyzer_lexatom_t*  low      = BeginP;
    const TestAnalyzer_lexatom_t*  up       = EndP;
    const TestAnalyzer_lexatom_t*  iterator = (const TestAnalyzer_lexatom_t*)0x0; 

    /* Binary Search for the interval where 'C' belongs:
     * Find iterator so that: *(iterator-1) <= C < *(iterator) */
    while( up != low ) {
        iterator = low + ((up - low) >> 1);
        if( C < *iterator ) {
            if( iterator == BeginP )        break;
            else if( *(iterator - 1) <= C ) break; 
            up  = iterator;
        }
        else if( C >= *iterator ) { 
            if( iterator == EndP - 1 )      { iterator = EndP; break; }
            low = iterator;
        }
    }
    S->interval_list.counter[iterator - BeginP] += 1;
}

inline void
TestAnalyzer_statistics_save(const char* Filename)
{
    const TestAnalyzer_statistics_state*  BeginP = (const TestAnalyzer_statistics_state*)TestAnalyzer_statistics_state_list;
    const TestAnalyzer_statistics_state*  EndP   = TestAnalyzer_statistics_state_list_end;
    const TestAnalyzer_statistics_state*  s      = (const TestAnalyzer_statistics_state*)0x0;
    FILE*                               fh     = __QUEX_STD_fopen(Filename, "w");
    size_t                              i      = 0;

    if( fh == NULL ) return;

    for(s = BeginP; s != EndP; ++s) {
        fprintf(fh, "{\nmode: %s;\nstate: %i; {\n", (const char*)s->mode_name, (int)s->state_index);
        for(i = 0; i != s->interval_list.boundary_n; ++i) {
            fprintf(fh, "%i ", (int)s->interval_list.boundary[i]);
        }
        fprintf(fh, ";\n");
        for(i = 0; i != s->interval_list.boundary_n + 1; ++i) {
            fprintf(fh, "%i ", (int)s->interval_list.counter[i]);
        }
        fprintf(fh, ";\n}\n");
    }

    fclose(fh);
}

#endif /* QUEX_INCLUDE_GUARD_TestAnalyzer__ANALYZER__STATISTICS_I */


